/* 
 * 
 * Copyright (c) Year(s), 2013, Luis M. S. Russo and Alexandre 
 * P. Francisco / KDBIO / INESC-ID, <qhv@kdbio.inesc-id.pt> 
 *  
 * Any published media that is related with to use of the distributed 
 * software, or derived software, must contain a reference to "Extending 
 * quick hypervolume. Luís M. S. Russo, Alexandre P. Francisco: 
 * J. Heuristics 22(3): 245-271 (2016)".
 *  
 * Permission to use, copy, modify, and/or distribute this software for 
 * any purpose with or without fee is hereby granted, provided that the 
 * above copyright notice and this permission notice appear in all 
 * copies. 
 *  
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL 
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE 
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL 
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER 
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 * 
 */

/**
 * @file   pointStruct.h
 * @author Luis Russo <lsr@Microknoppix>
 * @date   Mon Jul 30 15:32:19 2012
 * 
 * @brief  The definition of a point stucture. 
 * 
 * 
 */


#ifndef PointStruct_H
#define PointStruct_H

/// D is the number of dimensions
#ifndef D                       /**< Accept compiler options */
#define D 6                     /**< The number of dimensions */
#endif /* D */

/// Point is an array of coordinates, in a struct for simple and fast copy
struct point{
#if (D & 1)
  double x[D+1];
#else /* (D & 1) */
  double x[D];
#endif /* (D & 1) */
};
/// All points must be aligned for SSE2
typedef struct point __attribute__ ((aligned (16))) point;

#endif /* PointStruct_H */
